<div class="col-md-12">
    <div class="card card-container">

      <form
        *ngIf="!isSuccessful"
        name="form"
        (ngSubmit)="f.form.valid && onSubmit()"
        #f="ngForm"
        novalidate
      >
        <div class="form-group">
          <label for="username">Username</label>
          <input
            type="text"
            class="form-control"
            name="username"
            [(ngModel)]="form.username"
            required
            minlength="3"
            maxlength="20"
            #username="ngModel"
          />
          <div class="alert-danger" *ngIf="f.submitted && username.invalid">
            <div *ngIf="username.errors?.['required']">Username is required</div>
            <div *ngIf="username.errors?.['minlength']">
              Username must be at least 3 characters
            </div>
            <div *ngIf="username.errors?.['maxlength']">
              Username must be at most 20 characters
            </div>
          </div>
        </div>
        <div class="form-group">
          <label for="url">URL</label>
          <input
            type="text"
            class="form-control"
            name="url"
            [(ngModel)]="form.url"
            required
            url
            #url="ngModel"
          />
          <div class="alert-danger" *ngIf="f.submitted && url.invalid">
            <div *ngIf="url.errors?.['required']">URL is required</div>
            <!-- <div *ngIf="url.errors.url">
              URL must be a valid email address
            </div> -->
          </div>
        </div>
      
        <div class="form-group">
          <button class="btn btn-primary btn-block">Sign Up</button>
        </div>
  
        <div class="alert alert-warning" *ngIf="f.submitted && isSignUpFailed">
          Signup failed!<br />{{ errorMessage }}
        </div>
      </form>
  
      <div class="alert alert-success" *ngIf="isSuccessful">
        {{ successMessage }}
      </div>
    </div>
  </div>